/* ------------------------------------------------------------------------
	poster.c

	A Citadel utility to post files as multi-part citnet messages.

	Written by Audin Malmin.

	This code is Public Domain.  So do with it as you please.

	However, if you sell it then you will become very evil and I shall
	probably never speak to you again.

	There is, of course, no warranty what so ever.  This code works fine
	on my system and the few others it's been used on.  But if it makes
	your system melt down in front of your eyes then its your own fault.

	If you have questions or comments, I can be reached at:

	Magrathea @ Skaro, Olympia [skr.olm]  (CitNet)

	amalmin@halcyon.com  (Internet)

	or, if all else fails:

	Audin Malmin
	1317 Horne St. N.E.
	Olympia, WA 98516-5613

 --------------------------------------------------------------------------
 History:  (is in a seperate file...poster.txt.)
 -------------------------------------------------------------------------- */

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dos.h>
#include  <dir.h>
#include  <time.h>
#include  <io.h>
#include  "..\stat\pragmas.h"

#define	LABELSIZE	30

typedef char label[LABELSIZE+1];

time_t	timestamp;

FILE	*in, *out, *altout;

label	SID          = "",		// Source ID
		stamp	     = "",		// Time Stamp
		name	     = "",
		title	     = "",
		surname	     = "",
		group	     = "",
		phone	     = "",
		twit_region  = "",
		twit_country = "",
		mail_to	     = "",		// Mail- recipient
		node_to      = "",      // Mail- node to send mail to
		address_to   = "",      // '>' Mail- Address of node to send mail to
		public_to    = "",      // 'f' Public- Public TO field.
		realname     = "",
		fromnode     = "",
		fromaddress  = "",
		room	     = "",
		state	     = "",
		region       = "";

label	version	= "Poster 2.02";

long	fuckedtime,
		filesize,           	// Used in the init display and comment field.
		totalparts = 0,			// ""
		startpoint = 0;			// Number of lines to skip at start of file.

long    minfsize = 0,           //
        maxfsize = 0;           //

int		ID,						// Local ID field.  Ignored by Citadel.
		part     = 0,			// The current part number.
		spaces   = 1,			// 0 = ^A5, 1 = ' ', 2 = alt. (2 not finished)
		unix     = 0,			// 1 = Strip unix mail header.
        unixgate = 0,           // 1 = try to gate unix mail file.
		partsize = 8000,		// Part size.  Default = 8000. configurable.
		append	 = 0,			// 1 = allow appending to an existing packet.
		montyl	 = 0;			// Output the message text to another file.

char    input[257],				// Input file.
		configfile[257] = "poster.cfg",
		altname[257] = "",
		messagetext[8193],		// The main body of the message.Minus the endstring.
		extratext[257],			// The end of the last line of the messagetext.
		progname[257],			// Used in the help menu.
		subject[81] = "",		// Subject of the messages...
		sig1[81]	= "",		// User Signature line.
		sig2[81]	= "",		// BBS Signature line.
		fpath[257]	= "",		// The Forced Path field. 'P'.
		usrcomment[257] = "",	// One user comment '%' field.(Should be unlimited number.)
		gateway[257]	= "",	// The '*' gateway field.
		endstr[257]     = "",	// The string to STOP posting on.
		startstr[257]   = "";	// The string to START posting from.

void	startup(void);
int		config(void);
void	envr(void);
void 	putmsg(void);
int 	GetStr(char *str, int mlen);
void 	PutStr(FILE *fl, char *str);
void 	PutStr1(FILE *fl, char *str);
void	usage(void);

/* Main */
int main(int argc, char *argv[])
{
int		good = 0, done = 0, i;
char	*endpt = 0;

	strcpy(progname, argv[0]);
	strlwr(progname);

	printf("\n"
		   "%s (%s %s)\n"
		   "\n"
		   "By Magrathea @ Skaro, Olympia [skr.olm]\n"
		   "amalmin@halcyon.com\n"
		   "\n", version, __TIME__, __DATE__);

	if(argc < 2)
	{
		usage();
		exit(1);
	}

	config();
	envr();

	if(argc > 2)
		strcpy(name, argv[2]);
	if(argc > 3)
		strcpy(room, argv[3]);

	strcpy(input, argv[1]);

	startup();

	if(filesize == 0)
	{
		printf("Duh...Your input file \"%s\" is empty...\n", input);
        unlink("msg.69");
		exit(1);
	}

    if(minfsize && filesize < minfsize)
    {
        printf("Poster: Your input file \"%s\" is smaller than your MINSIZE setting.\n", input);
        unlink("msg.69");
        exit(2);
    }

    if(maxfsize && filesize > maxfsize)
        {
        printf("Poster: Your input file \"%s\" is larger than your MAXSIZE setting.\n", input);
        unlink("msg.69");
        exit(2);
        }

	printf("From        : [%s] %s [%s] @\n"
		   "            : %s, %s, %s [%s]\n"
		   "Real name   : %-30.30s  Roomname : %s\n"
		   "Group       : %-30.30s  Phone    : %s\n"
		   "Twit_Region : %-30.30s  T_Country: %s\n"
		   "Mail to     : %s @ %s [%s]\n"
		   "Public to   : %s\n"
		   "Subject     : %s\n"
		   "User sig    : %s\n"
		   "BBS sig     : %s\n"
		   "Forced path : %s\n"
		   "Input file  : %s\n"
		   "File size   : %-30ld  Part size: %d\n",
		   title, name, surname, fromnode, region, state, fromaddress,
		   realname, room, group, phone, twit_region,
		   twit_country, mail_to, node_to, address_to, public_to,
		   subject, sig1, sig2, fpath, input, filesize, partsize);

	totalparts = (filesize/partsize)+1;

	printf("Total parts : %ld\n", totalparts);

	printf("Append mode : %s\n\n", (append) ? "On" : "Off");

	time(&timestamp);
	fuckedtime = timestamp;

	sprintf(SID, "%ld", timestamp);

	if(spaces)
		printf("Don't use ^A5...\n");

	if(montyl)
		printf("Also copying message text to: %s\n", altname);

	if(startpoint)
	{
		printf("Starting Point: %ld\n", startpoint);
		for(i = 0; i<startpoint;i++)
		{
			fgets(messagetext, 257, in);
			messagetext[0] = 0;
		}
	}

	if(unix)
	{
		printf("Unix Mail.\n");
		do
		{
			fgets(messagetext, 1024, in);
			if(messagetext[0] == '\n')
				done = 1;
		} while(!done && !feof(in));
	}

	done = 0;

	if(startstr[0])
	{
		printf("\nStarting at text: \"%s\"\n", startstr);
		while(!done && !feof(in))
		{
			fgets(messagetext, 257, in);
			if(strstr(messagetext, startstr) != NULL)
			{
				done = 1;
				strcpy(startstr, messagetext);
			}
		}
	}

	if(endstr[0])
		printf("Ending at text: \"%s\"", endstr);

	printf("\n");

	while(!good && !endpt)
	{
		good = GetStr(messagetext, partsize);

		fgets(extratext, 128, in);
		strcat(messagetext, extratext);
			/* makes sure each part ends with complete line */

		fuckedtime++;                     /* defeat cit's dup checking. */
		sprintf(SID, "%ld", fuckedtime);  /* uses the time as the source id...*/

		if(endstr[0])
		{
			endpt = strstr(messagetext, endstr);
			if(endpt)
				*endpt = 0;  // Null off the message text.
		}

		if(montyl)			// Make a copy of the message text.
		{
			if(startstr[0])
			{
				if(spaces)
					fputc(' ', altout);
				fputs(startstr, altout);
			}

			if(spaces)
				fputc(' ', altout);
			fputs(messagetext, altout);
		}

		putmsg();

		messagetext[0] = 0;
		extratext[0]   = 0;
	}
	return(0);
}

/* ------------------------------------------------------------------------ */
/*  putmsg() -- Writes a message out to the 'out' stream.                   */
/* ------------------------------------------------------------------------ */
void putmsg(void)
{
	char comment[257];

	printf("writing message # %d\n", part);

	part++;

//	if(part > totalparts)
//		return;

	/* write start of message */
	fputc(0xFF, out);			/* 0xFF to start things off... */
	fputc(0x00, out);			/* fake the attribute bits... */

	/* put local ID # out */
	PutStr(out, SID);

	/* Write out the message header... */
	fputc('A', out); PutStr(out, name);

	time(&timestamp);
	sprintf(stamp, "%ld", timestamp);
	fputc('D', out); PutStr(out, stamp);

	fputc('O', out); PutStr(out, fromnode);
	fputc('S', out); PutStr(out, SID);
	fputc('P', out); PutStr(out, fromaddress);
	fputc('s', out); PutStr(out, version);

	if(!startstr[0] && !endstr[0] && !startpoint)
		sprintf(comment, "%s, %ld bytes, Part %d of %ld.",
				input, filesize, part, totalparts);
	else
		sprintf(comment, "%s, originally %ld bytes, Part %d.",
				input, filesize, part);

	fputc('%', out); PutStr(out, comment);

//	fputc('%', out); PutStr(out, "Precedence: Bulk");

	if(region[0])       { fputc('o', out); PutStr(out, region);      	}
	if(state[0])        { fputc('Q', out); PutStr(out, state);	    	}
	if(subject[0])      { fputc('B', out); PutStr(out, subject);     	}
	if(title[0])        { fputc('N', out); PutStr(out, title);       	}
	if(surname[0])      { fputc('n', out); PutStr(out, surname);     	}
	if(group[0])        { fputc('G', out); PutStr(out, group);       	}
	if(phone[0])        { fputc('H', out); PutStr(out, phone);       	}
	if(twit_region[0])  { fputc('J', out); PutStr(out, twit_region); 	}
	if(twit_country[0]) { fputc('j', out); PutStr(out, twit_country);	}
	if(mail_to[0])      { fputc('T', out); PutStr(out, mail_to);     	}
	if(node_to[0])      { fputc('Z', out); PutStr(out, node_to);     	}
	if(address_to[0])   { fputc('>', out); PutStr(out, address_to);  	}
	if(public_to[0])    { fputc('t', out); PutStr(out, public_to);  	}
	if(realname[0])     { fputc('!', out); PutStr(out, realname);   	}
	if(fpath[0])        { fputc('p', out); PutStr(out, fpath);	    	}
	if(sig1[0])         { fputc('_', out); PutStr(out, sig1);        	}
	if(sig2[0])			{ fputc('.', out); PutStr(out, sig2);        	}
//	if(gateway[0])		{ fputc('*', out); PutStr(out, gateway);		}
	if(usrcomment[0])	{ fputc('%', out); PutStr(out, usrcomment);  	}

	fputc('M', out);

	if(!spaces)
	{
		fputc('', out);
		fputc('5', out);
	} else
		fputc(' ', out);

	PutStr1(out, "0aPrecedence: Bulk0\n");

	if(spaces)
		fputc(' ', out);

	if(startstr[0])
	{
		PutStr1(out, startstr);

		if(spaces)
			fputc(' ', out);
	}

	PutStr(out, messagetext);
}

/* -------------------------------------------------------------------- */
/*  GetStr() - Gets an mlen length chunk of text from the text file.    */
/*			   This also ads spaces as needed...(as set by spaces.)     */
/* -------------------------------------------------------------------- */
int GetStr(char *str, int mlen)
{
	int	l = 0;
	unsigned char ch = 1;

	if(spaces == 0)			// No spaces needed, using ^A5
	{
		while(!feof(in) && l <mlen)
		{
			ch=(unsigned char)fgetc(in);
			if (!feof(in) && l < mlen)
			{
				str[l]=ch;
				l++;
			}
		}
		str[l]='\0';
	}
	else
		if(spaces == 1)     // Spaces needed.  Using compatable mode.
		{
			while(!feof(in) && l <mlen)
			{
				ch=(unsigned char)fgetc(in);
				if(!feof(in) && l < mlen)
				{
					str[l]=ch;
					l++;

					if(ch == '\n')
					{
						str[l]=' ';
						l++;
					}
				}
			}
			str[l]='\0';
		}
		else
			if(spaces == 2)		// And this i have yet to write.
			{
			}

	if(!feof(in))
		return 0;
	else
		return 1;
}

/* -------------------------------------------------------------------- */
/*  PutStr()        puts a null-terminated string to a file             */
/* -------------------------------------------------------------------- */
/*					This is from DragCit.								*/
/* -------------------------------------------------------------------- */
void PutStr(FILE *fl, char *str)
{
	fwrite(str, sizeof(char), (strlen(str) + 1), fl);
}

/* Same as above...  but without the null... */
void PutStr1(FILE *fl, char *str)
{
	fwrite(str, sizeof(char), strlen(str), fl);
}

/* -------------------------------------------------------------------- */
/*  startup()  --  startup...  opens all files.                         */
/* -------------------------------------------------------------------- */
void startup(void)
{
	if ((in = fopen(input, "rb")) == NULL)
	{
		printf("\n\n Hmm...  I can't seem to find \"%s\".\n", input);
		exit(1);
	}

	if(!append)
	{
		if ((out = fopen("msg.69", "wb")) == NULL)
		{
			printf("\n\n I need to write to \"MSG.69\", but I can't seem to open it.\n"
				   "Append mode has to be on if you want to add to an old packet.\n");
			exit(1);
		}
	} else
	{
		if((out = fopen("msg.69", "r")) != NULL)
			{
			append = 2;
			fclose(out);
			}

		if((out = fopen("msg.69", "ab")) == NULL)
		{
			printf("\n\n Well, you're in append mode...but i still can't seem to open MSG.69...\n");
			exit(1);
		}
	}

	if(montyl)
	{
		if((altout = fopen(altname, "wb")) == NULL)
		{
			printf("\n\n I can't seem to open %s as the Comp output file.\n", altname);
			exit(1);
		}
	}

	filesize = filelength(fileno(in));

	if(append != 2)
		PutStr(out, fromaddress);		// Output the address.
	else
		fputc(0x00, out);

	PutStr(out, room);              // And the roomname.
}

/* ------------------------------------------------------------------- */
/* config()  --  Reads a config file.                                  */
/* ------------------------------------------------------------------- */
int config(void)
{
	int i;
	FILE *cfg;
	char line[257], word1[257], lword1[257];
	char *text;
	char drive[5] = "", dir[257] = "";

	static char *KEYWORD[] = {
		"AUTHOR",				/* 0  - 'A'uthor field            */
		"NODE",                 /* 1  - 'O'riginating Node        */
		"ADDRESS",      		/* 2  - first entry in 'P'ath     */
		"REGION",	        	/* 3  - 'o' region field          */
		"DEFAULT_ROOM",         /* 4  - 'R' field                 */
		"UNIX_MAIL",            /* 5  - start after first blank line */
		"DELAYED_START",        /* 6  - line number to start on   */
		"START_STRING",         /* 7  - The string to start with  */
		"SUBJECT",              /* 8  - 'B' Subject field         */
		"END_STRING",           /* 9  - The string to end with    */
		"COMMENT",              /* 10 - '%' comment field (any #) */
		"TITLE",                /* 11 - 'N' Title field           */
		"SURNAME",              /* 12 - 'n' Surname field         */
		"SIGNATURE1",			/* 13 - '_' User Sig field        */
		"SIGNATURE2",           /* 14 - '.' BBS Sig field         */
		"GROUP",                /* 15 - 'G'roup field             */
		"PHONE",                /* 16 - 'H' Phone number field    */
		"TWIT_REGION", 			/* 17 - 'J' Twit region field     */
		"TWIT_COUNTRY",         /* 18 - 'j' Twit country field    */
		"MAIL_TO_USER",         /* 19 - E-Mail 'T'o field         */
		"FORCED_PATH",          /* 20 - 'p' forced path field     */
		"REAL_NAME",            /* 21 - '!' Real name field       */
		"MAIL_TO_NODE",         /* 22 - 'Z' Destination node name */
		"MAIL_TO_ADD",          /* 23 - '>' Destination address   */
		"COUNTRY",				/* 24 - 'Q' county/state field    */
		"PUBLIC_TO",			/* 25 - 't' public 'to' field     */
		"FORMATTING",			/* 26 - if 1 then don't use ^A5   */
		"PART_SIZE",			/* 27 - the size of one message.  */
		"GATEWAY",				/* 28 - the '*' gateway field.    */
		"APPEND",				/* 29 - allow posting of multiple files. */
		"COMP",					/* 30 - send message to an extra file.. */
        "unixgate",             // 31
        "maxsize",              // 32 maxfsize setting.
        "minsize",              // 33 minfsize.
		NULL
		};


	if ((cfg = fopen (configfile, "rt")) == NULL)
	{
		fnsplit(progname, drive, dir, NULL, NULL);
		sprintf(configfile, "%s%sposter.cfg", drive, dir);
		printf("Config file might be: %s\n\n", configfile);
		if((cfg = fopen(configfile, "rt")) == 0)
		{
			printf ("No config file present.\n\n");
			return 0;
		}
	}
	else
	{
		printf("Config file \"%s\" found.\n\n", configfile);
	}

	while (!feof (cfg))
	{
		text = fgets(line, sizeof(line), cfg);
		if(text == 0)
			break;
		if(line[0] != '#')
			continue;

		i = sscanf(line, "%s \"%255[^\"\n\r\t]", word1, lword1);

		if(i == 1)
			i = sscanf(line, "%s %255s", word1, lword1);
		if(i != 2)
			continue;

		for(i = 0; KEYWORD[i] != NULL; i++)
			if(stricmp(&word1[1], KEYWORD[i]) == 0)
			   break;

		switch (i)
		{
			case 0:
				lword1[31] = 0;
				strcpy(name, lword1);
				break;
			case 1:
				lword1[31] = 0;
				strcpy(fromnode, lword1);
				break;
			case 2:
				lword1[31] = 0;
				strcpy(fromaddress, lword1);
				break;
			case 3:
				lword1[31] = 0;
				strcpy(region, lword1);
				break;
			case 4:
				lword1[31] = 0;
				strcpy(room, lword1);
				break;
			case 5:
				if(lword1[0] == '1')
					unix = 1;
				else
					unix = 0;
				break;
			case 6:
				startpoint = atol(lword1);
				break;
			case 7:
				lword1[256] = 0;
				strcpy(startstr, lword1);
				break;
			case 8:
				lword1[81] = 0;
				strcpy(subject, lword1);
				break;
			case 9:
				lword1[256] = 0;
				strcpy(endstr, lword1);
				break;
			case 10:
				lword1[256] = 0;
				strcpy(usrcomment, lword1);
				break;
			case 11:
				lword1[31] = 0;
				strcpy(title, lword1);
				break;
			case 12:
				lword1[31] = 0;
				strcpy(surname, lword1);
				break;
			case 13:
				lword1[81] = 0;
				strcpy(sig1, lword1);
				break;
			case 14:
				lword1[81] = 0;
				strcpy(sig2, lword1);
				break;
			case 15:
				lword1[31] = 0;
				strcpy(group, lword1);
				break;
			case 16:
				lword1[31] = 0;
				strcpy(phone, lword1);
				break;
			case 17:
				lword1[31] = 0;
				strcpy(twit_region, lword1);
				break;
			case 18:
				lword1[31] = 0;
				strcpy(twit_country, lword1);
				break;
			case 19:
				lword1[31] = 0;
				strcpy(mail_to, lword1);
				break;
			case 20:
				lword1[257] = 0;
				strcpy(fpath, lword1);
				break;
			case 21:
				lword1[31] = 0;
				strcpy(realname, lword1);
				break;
			case 22:
				lword1[31] = 0;
				strcpy(node_to, lword1);
				break;
			case 23:
				lword1[8] = 0;
				strcpy(address_to, lword1);
				break;
			case 24:
				lword1[31] = 0;
				strcpy(state, lword1);
				break;
			case 25:
				lword1[31] = 0;
				strcpy(public_to, lword1);
				break;
			case 26:
				if(lword1[0] == '1')
					spaces = 1;
				else
					spaces = 0;
				break;
			case 27:
				partsize = atoi(lword1);
				break;
			case 28:
				lword1[257] = 0;
				strcpy(gateway, lword1);
				break;
			case 29:
				if(lword1[0] == '1')
					append = 1;
				else
					append = 0;
				break;
			case 30:
				lword1[257] = 0;
				montyl = 1;
				strcpy(altname, lword1);
				break;

            case 31:
                 unixgate = 1;
                 break;

            case 32:   // maxsize
                 maxfsize = atol(lword1);
                 break;

            case 33:   // minsize
                 minfsize = atol(lword1);
                 break;

			 default:
				printf("Keyword '%s' unknown.\n", word1);
				break;
		}
	}
	fclose(cfg);
	return 1;
}

/*************************************************************************/
/* envr() -- sets a couple of things from environmental vars...          */
/*************************************************************************/
void envr(void)
{
	char *ptr;

	ptr = getenv("SUBJECT");
	if(ptr)
		strncpy(subject, ptr, 80);

	ptr = 0;
	ptr = getenv("GATEWAY");
	if(ptr)
		strncpy(gateway, ptr, 256);
}

/****************************************************************************/
/* usage()                                                                  */
/****************************************************************************/
void usage(void)
{
	printf("Usage: %s filename [author room]\n"
		   "\n"
	       "  These two args are optional and will take precidence over anything in the\n"
	       "  poster.cfg file.\n"
	       "\n"
	       "	author == author of messages.\n"
	       "	  room == room messages show up in.\n"
	       "\n"
	       "Any multi-word args MUST be in quotes.\n\n", progname);
}